<?php

namespace Aerex\TaskwarriorPlugin\Processors;
use Aerex\TaskwarriorPlugin\TaskwarriorManager;
use Sabre\VObject\Component\VTodo;

/**
 * Class ToDo
 * 
 * @author Aerex
 */
class CalendarProcessor
{

  public function __construct(TaskwarriorManager $taskwarriorManager){
      $this->taskwarriorManager = $taskwarriorManager;
  }

  public function importTask(VTodo $Todo){

       if($this->taskwarriorManager->exists($Todo->UID)){
         $this->taskwarriorManager->updateTask($Todo);
       }


       try {
         $this->taskwarriorManager->addTask($Todo);

       } catch(Exception $e){
         echo $e->getMessage();
         throw $e;
       }

  }

  public function export(){
    echo "Not yet implemented";
  }

}


?>
