<?php

namespace Aerex\TaskwarriorPlugin\Taskwarrior;
use Symfony\Component\Process\Process;
use Aerex\TaskwarriorPlugin\Commands\IStrategy;

class Taskwarrior {
  
  const EXPORT = 'export';
  const IMPORT = 'import'; 
    const ADD = 'add';

    /**
     * @var TaskwarriorConfig
     */
    private $config;

   /**
     * @var string
     */
    private $bin;

    /**
     * @var string
     */
    private $taskrc;

    /**
     * @var string
     */
    private $taskData;

    /**
     * @var array
     */
    private $rcOptions;

    /**
     * @var string
     */
  
    public function __construct(TaskwarriorConfig $config){
      if(!isset($config)){
        $this->config = new TaskwarriorConfig();
      }
      $this->config = $config;
    }

    public function setStrategy(IStrategy $strategy){
      $this->strategy = $strategy;
    }

    public function createTask($uuid){
      $task = new Task($uuid);
      return $task;
    }


    public function add($task){
      $this->strategy($task);
    }

}


?>
